#include <iostream>
#include <vector>
#include <cstdlib>
#include <ctime>

using namespace std;

int w, h, p;
vector<vector<char> > map;

int main(){
	srand(time(0));

	// read input
	cin >> w >> h >> p;
	map.resize(w, vector<char>(h));
	for(int y = 0; y < h; y++){
		for(int x = 0; x < w; x++){
			cin >> map[x][y];
		}
	}

	// determine start position
	bool startPlaced = false;
	for(int y = 0; y < h && !startPlaced; y++){
		for(int x = 0; x < w && !startPlaced; x++){
			if(map[x][y] == '='){
				cout << x << " " << y << endl;
				startPlaced = true;
				break;
			}
		}
	}

	// play forever
	while(true){
		int player;
		cin >> player;

		// the game is over
		if (player == 0){
			return 0;
		}
		// read all players
		for(int i = 0; i < p; i++){
			cin >> player;
			if(player == 0){ // it's me, calculate random next position
				int x, y, vx, vy, newVX, newVY, bombsLeft, freezersLeft;
				// read the current position
				cin >> x >> y >> vx >> vy >> bombsLeft >> freezersLeft;
				// try to find a field we don't crash
				for(int j = 0; j < 1000; j++){
					newVX = vx + (rand() % 3) - 1;
					newVY = vy + (rand() % 3) - 1;
					if((x+newVX) < 0 || (x+newVX) >= w || (y+newVY) < 0 || (y+newVY) >= h){
						continue;
					}
					if(map[x+newVX][y+newVY] != '#'){
						break;
					}
				}
				// randomly use bomb
				if(bombsLeft > 0 && rand() % 50 == 42){
					int x, y;
					for(int j = 0; j < 1000; j++){
						x = rand() % w;
						y = rand() % h;
						if(map[x][y] != '#'){
							break;
						}
					}
					cout << "B " << x << " " << y << endl;
				}
				// randomly use freezer
				if(freezersLeft > 0 && rand() % 50 == 42){
					int x, y;
					for(int j = 0; j < 1000; j++){
						x = rand() % w;
						y = rand() % h;
						if(map[x][y] != '#'){
							break;
						}
					}
					cout << "F " << x << " " << y << endl;
				}
				cout << "M " << x + newVX << " " << y + newVY << endl;
			} else {
				// it's another player, we don't care about it in this sample.
				int ignoreInput;
				cin >> ignoreInput >> ignoreInput >> ignoreInput >> ignoreInput >> ignoreInput >> ignoreInput;
			}
		}
		// ignore the planted bombs
		int ignoreBombs, ignoreFreezers;
		cin >> ignoreBombs >> ignoreFreezers; // bombs and freezers
		for(int i = 0; i < ignoreBombs + ignoreFreezers; i++){
			int ignoreInput;
			cin >> ignoreInput >> ignoreInput >> ignoreInput;
		}
	}

	return 0;
}
