import java.awt.Point;
import java.util.ArrayList;
import java.util.Random;
import java.util.Scanner;

public class RacingSample {

    public static void main(String[] args) {

        Scanner cin = new Scanner(System.in);
        int width, height, players;
        width = cin.nextInt();
        height = cin.nextInt();
        players = cin.nextInt();
        cin.nextLine();

        //parse map
        char[][] map = new char[width][height];
        ArrayList<Point> startpos = new ArrayList<>();
        for (int y = 0; y < height; y++) {
            String line = cin.nextLine();
            for (int x = 0; x < width; x++) {
                map[x][y] = line.charAt(x);
                if (map[x][y] == '=') {
                    startpos.add(new Point(x, y));
                }
            }
        }

        //send start position
        Point selected = startpos.get(new Random().nextInt(startpos.size()));
        System.out.println((int) selected.x + " " + (int) selected.y);

        boolean usedBomb, usedFreezer;
        usedBomb = usedFreezer = false;

        for (int round = 0;; round++) {
            int x, y, vx, vy;
            x = y = vx = vy = 0;
            if (cin.nextInt() != 1) {
                //exit when game is over
                break;
            }
            //read other players positions
            for (int i = 0; i < players; i++) {
                int id = cin.nextInt();
                int posx = cin.nextInt();
                int posy = cin.nextInt();
                int velx = cin.nextInt();
                int vely = cin.nextInt();
                int bombsRemaining = cin.nextInt();
                int freezersRemaining = cin.nextInt();
                //get own position
                if (id == 0) {
                    x = posx;
                    y = posy;
                    vx = velx;
                    vy = vely;
                }
            }

            int bombs = cin.nextInt();
            int freezers = cin.nextInt();

            for (int i = 0; i < bombs; i++) {
                //get bomb/freezer details
                int posx = cin.nextInt();
                int posy = cin.nextInt();
                int player = cin.nextInt();
                //possibly use this information for sth
            }
            for (int i = 0; i < freezers; i++) {
                //get bomb/freezer details
                int posx = cin.nextInt();
                int posy = cin.nextInt();
                int player = cin.nextInt();
                //possibly use this information for sth
            }

            //use bombs/freezers
            if (round > new Random().nextInt(20)) {
                if (!usedBomb) {
                    usedBomb = true;
                    System.out.println("B " + x + " " + y);
                } else if (!usedFreezer) {
                    usedFreezer = true;
                    System.out.println("F " + x + " " + y);
                }
            }

            //move
            ArrayList<Point> possibleMoves = new ArrayList<>();
            for (int dx = -1; dx <= 1; dx++) {
                for (int dy = -1; dy <= 1; dy++) {
                    if (x + vx + dx < 0 || y + vy + dy < 0 || x + vx + dx >= width || y + vy + dy >= height) {
                        continue;
                    }
                    if (map[x + vx + dx][y + vy + dy] == '#') {
                        continue;
                    }
                    possibleMoves.add(new Point(x + vx + dx, y + vy + dy));
                }
            }
            if (possibleMoves.isEmpty()) {
                System.out.println("M " + (x + vx) + " " + (y + vy));
            } else {
                Point chosen = possibleMoves.get(new Random().nextInt(possibleMoves.size()));
                System.out.println("M " + ((int) chosen.getX()) + " " + ((int) chosen.getY()));
            }

            // System.err.println("Hello world!"); //you could print to stderr for debugging
        }
    }
}
